LeetCode 1. 两数之和

1. Two Sum

Given an array of integers nums and an integer target, return indices of the two numbers such that they add up to target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

You can return the answer in any order.

Example 1:

Input: nums = [2,7,11,15], target = 9

Output: [0,1]

Explanation: Because nums[0] + nums[1] == 9, we return [0, 1].

Example 2:

Input: nums = [3,2,4], target = 6

Output: [1,2]

Example 3:

Input: nums = [3,3], target = 6

Output: [0,1]

Constraints:

  • 2 <= nums.length <= 10^4
  • -10^9 <= nums[i] <= 10^9
  • -10^9 <= target <= 10^9
     

Only one valid answer exists.

Follow-up: Can you come up with an algorithm that is less than O(n2) time complexity?

解法思路:

1、暴力求解

2、利用map集合的特性

class Solution {
    public int[] twoSum(int[] nums, int target) {
        // 暴力求解,O(n^2)
        // int[] res = new int[2];
        // for (int i = 0; i < nums.length - 1; i++) {
        //     for (int j = i + 1; j < nums.length; j++) {
        //         if (nums[i] + nums[j] == target) {
        //             res[0] = i;
        //             res[1] = j;
        //             return res;
        //         }
        //     }
        // }
        // return new int[0];

        // O(n)
        // Map<Integer, Integer> map = new HashMap<>();
        // int[] res = new int[2];
        // for (int i = 0; i < nums.length; i++) {
        //     int anotherNum = target - nums[i];
        //     if (map.containsKey(anotherNum)) {
        //         res[0] = map.get(anotherNum);
        //         res[1] = i;
        //         return res;
        //     }
        //     map.put(nums[i], i);
        // }
        // return new int[0];

        // 优化下
        Map<Integer, Integer> map = new HashMap<>();
        int n = nums.length;
        for (int i = 0; i < n; i++) {
            int anotherNum = target - nums[i];
            if (map.containsKey(anotherNum)) {
                return new int[]{map.get(anotherNum), i};
            } else {
                map.put(nums[i], i);
            }
        }
        return null;
    }
}

 

相关推荐

  1. LeetCode 1. 之和

    2023-12-18 02:24:05       57 阅读
  2. leetcode 1之和

    2023-12-18 02:24:05       32 阅读
  3. LeetCode1之和

    2023-12-18 02:24:05       17 阅读
  4. Leetcode 1.之和

    2023-12-18 02:24:05       11 阅读

最近更新

  1. TCP协议是安全的吗?

    2023-12-18 02:24:05       14 阅读
  2. 阿里云服务器执行yum,一直下载docker-ce-stable失败

    2023-12-18 02:24:05       16 阅读
  3. 【Python教程】压缩PDF文件大小

    2023-12-18 02:24:05       15 阅读
  4. 通过文章id递归查询所有评论(xml)

    2023-12-18 02:24:05       18 阅读

热门阅读

  1. leetcode142.环形链表II

    2023-12-18 02:24:05       47 阅读
  2. fripside - promise lrc

    2023-12-18 02:24:05       32 阅读
  3. 如何安装docker

    2023-12-18 02:24:05       43 阅读
  4. C语言指针2

    2023-12-18 02:24:05       32 阅读
  5. 设计一个算法用于判断循环双链表是否对称。

    2023-12-18 02:24:05       37 阅读
  6. 【mysql】锁的类型有哪些呢?

    2023-12-18 02:24:05       36 阅读
  7. ES6之class类

    2023-12-18 02:24:05       31 阅读
  8. ubuntu18使用docker编译和运行的步骤

    2023-12-18 02:24:05       36 阅读
  9. 深入理解GPIO概念详讲

    2023-12-18 02:24:05       34 阅读